Index: tools/toolchain.sh
===================================================================
--- tools/toolchain.sh	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ tools/toolchain.sh	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -52,13 +52,4 @@
 #endif
 EOF
-
-BINUTILS_VERSION="2.21"
-GCC_VERSION="4.6.0"
-
-BASEDIR="`pwd`"
-BINUTILS="binutils-${BINUTILS_VERSION}.tar.bz2"
-GCC_CORE="gcc-core-${GCC_VERSION}.tar.bz2"
-GCC_OBJC="gcc-objc-${GCC_VERSION}.tar.bz2"
-GCC_CPP="gcc-g++-${GCC_VERSION}.tar.bz2"
 
 #
@@ -148,9 +139,8 @@
 	echo " sparc64    SPARC V9"
 	echo " all        build all targets"
-	echo " parallel   same as 'all', but in parallel"
 	echo
 	echo "The toolchain will be installed to the directory specified by"
 	echo "the CROSS_PREFIX environment variable. If the variable is not"
-	echo "defined, /usr/local/cross will be used by default."
+	echo "defined, /usr/local will be used by default."
 	echo
 	
@@ -204,5 +194,5 @@
 }
 
-download_fetch() {
+download_check() {
 	SOURCE="$1"
 	FILE="$2"
@@ -218,15 +208,4 @@
 }
 
-source_check() {
-	FILE="$1"
-	
-	if [ ! -f "${FILE}" ]; then
-		echo
-		echo "File ${FILE} not found."
-		
-		exit 4
-	fi
-}
-
 cleanup_dir() {
 	DIR="$1"
@@ -262,16 +241,25 @@
 }
 
-prepare() {
-	show_dependencies
-	check_dependecies
-	show_countdown 10
-	
-	BINUTILS_SOURCE="ftp://ftp.gnu.org/gnu/binutils/"
-	GCC_SOURCE="ftp://ftp.gnu.org/gnu/gcc/gcc-${GCC_VERSION}/"
-	
-	download_fetch "${BINUTILS_SOURCE}" "${BINUTILS}" "c84c5acc9d266f1a7044b51c85a823f5"
-	download_fetch "${GCC_SOURCE}" "${GCC_CORE}" "b1957f3209080b2f55bc3756d3a62b7c"
-	download_fetch "${GCC_SOURCE}" "${GCC_OBJC}" "120d4675366ee82ea52f9ed65b57da04"
-	download_fetch "${GCC_SOURCE}" "${GCC_CPP}" "a30090fa655d0db4c970740d353c81f1"
+patch_binutils() {
+	PLATFORM="$1"
+	
+	if [ "${PLATFORM}" == "arm32" ] ; then
+		patch -p1 <<EOF
+diff -Naur binutils-2.20.orig/gas/config/tc-arm.c binutils-2.20/gas/config/tc-arm.c
+--- binutils-2.20.orig/gas/config/tc-arm.c	2009-08-30 00:10:59.000000000 +0200
++++ binutils-2.20/gas/config/tc-arm.c	2009-11-02 14:25:11.000000000 +0100
+@@ -2485,8 +2485,9 @@
+       know (frag->tc_frag_data.first_map == NULL);
+       frag->tc_frag_data.first_map = symbolP;
+     }
+-  if (frag->tc_frag_data.last_map != NULL)
++  if (frag->tc_frag_data.last_map != NULL) {
+     know (S_GET_VALUE (frag->tc_frag_data.last_map) < S_GET_VALUE (symbolP));
++  }
+   frag->tc_frag_data.last_map = symbolP;
+ }
+EOF
+		check_error $? "Error patching binutils"
+	fi
 }
 
@@ -280,5 +268,16 @@
 	TARGET="$2"
 	
-	WORKDIR="${BASEDIR}/${PLATFORM}"
+	BINUTILS_VERSION="2.20"
+	GCC_VERSION="4.5.1"
+	
+	BINUTILS="binutils-${BINUTILS_VERSION}.tar.bz2"
+	GCC_CORE="gcc-core-${GCC_VERSION}.tar.bz2"
+	GCC_OBJC="gcc-objc-${GCC_VERSION}.tar.bz2"
+	GCC_CPP="gcc-g++-${GCC_VERSION}.tar.bz2"
+	
+	BINUTILS_SOURCE="ftp://ftp.gnu.org/gnu/binutils/"
+	GCC_SOURCE="ftp://ftp.gnu.org/gnu/gcc/gcc-${GCC_VERSION}/"
+	
+	WORKDIR="`pwd`"
 	BINUTILSDIR="${WORKDIR}/binutils-${BINUTILS_VERSION}"
 	GCCDIR="${WORKDIR}/gcc-${GCC_VERSION}"
@@ -286,5 +285,5 @@
 	
 	if [ -z "${CROSS_PREFIX}" ] ; then
-		CROSS_PREFIX="/usr/local/cross"
+		CROSS_PREFIX="/usr/local"
 	fi
 	
@@ -292,12 +291,14 @@
 	
 	echo ">>> Downloading tarballs"
-	source_check "${BASEDIR}/${BINUTILS}"
-	source_check "${BASEDIR}/${GCC_CORE}"
-	source_check "${BASEDIR}/${GCC_OBJC}"
-	source_check "${BASEDIR}/${GCC_CPP}"
+	download_check "${BINUTILS_SOURCE}" "${BINUTILS}" "ee2d3e996e9a2d669808713360fa96f8"
+	download_check "${GCC_SOURCE}" "${GCC_CORE}" "dc8959e31b01a65ce10d269614815054"
+	download_check "${GCC_SOURCE}" "${GCC_OBJC}" "3c11b7037896e967eddf8178af2ddd98"
+	download_check "${GCC_SOURCE}" "${GCC_CPP}" "b294953ff0bb2f20c7acb2bf005d832a"
 	
 	echo ">>> Removing previous content"
 	cleanup_dir "${PREFIX}"
-	cleanup_dir "${WORKDIR}"
+	cleanup_dir "${OBJDIR}"
+	cleanup_dir "${BINUTILSDIR}"
+	cleanup_dir "${GCCDIR}"
 	
 	create_dir "${PREFIX}" "destination directory"
@@ -305,15 +306,13 @@
 	
 	echo ">>> Unpacking tarballs"
-	cd "${WORKDIR}"
-	check_error $? "Change directory failed."
-	
-	unpack_tarball "${BASEDIR}/${BINUTILS}" "binutils"
-	unpack_tarball "${BASEDIR}/${GCC_CORE}" "GCC Core"
-	unpack_tarball "${BASEDIR}/${GCC_OBJC}" "Objective C"
-	unpack_tarball "${BASEDIR}/${GCC_CPP}" "C++"
+	unpack_tarball "${BINUTILS}" "binutils"
+	unpack_tarball "${GCC_CORE}" "GCC Core"
+	unpack_tarball "${GCC_OBJC}" "Objective C"
+	unpack_tarball "${GCC_CPP}" "C++"
 	
 	echo ">>> Processing binutils (${PLATFORM})"
 	cd "${BINUTILSDIR}"
 	check_error $? "Change directory failed."
+	patch_binutils "${PLATFORM}"
 	
 	change_title "binutils: configure (${PLATFORM})"
@@ -337,9 +336,11 @@
 	check_error $? "Error compiling/installing GCC."
 	
-	cd "${BASEDIR}"
+	cd "${WORKDIR}"
 	check_error $? "Change directory failed."
 	
 	echo ">>> Cleaning up"
-	cleanup_dir "${WORKDIR}"
+	cleanup_dir "${OBJDIR}"
+	cleanup_dir "${BINUTILSDIR}"
+	cleanup_dir "${GCCDIR}"
 	
 	echo
@@ -351,50 +352,47 @@
 fi
 
+show_dependencies
+check_dependecies
+show_countdown 10
+
 case "$1" in
 	"amd64")
-		prepare
 		build_target "amd64" "amd64-linux-gnu"
 		;;
 	"arm32")
-		prepare
 		build_target "arm32" "arm-linux-gnu"
 		;;
 	"ia32")
-		prepare
 		build_target "ia32" "i686-pc-linux-gnu"
 		;;
 	"ia64")
-		prepare
 		build_target "ia64" "ia64-pc-linux-gnu"
 		;;
+	"ia64")
+		build_target "ia64" "ia64-pc-linux-gnu"
+		;;
 	"mips32")
-		prepare
 		build_target "mips32" "mipsel-linux-gnu"
 		;;
 	"mips32eb")
-		prepare
 		build_target "mips32eb" "mips-linux-gnu"
 		;;
 	"mips64")
-		prepare
 		build_target "mips64" "mips64el-linux-gnu"
 		;;
 	"ppc32")
-		prepare
 		build_target "ppc32" "ppc-linux-gnu"
 		;;
 	"ppc64")
-		prepare
 		build_target "ppc64" "ppc64-linux-gnu"
 		;;
 	"sparc64")
-		prepare
 		build_target "sparc64" "sparc64-linux-gnu"
 		;;
 	"all")
-		prepare
 		build_target "amd64" "amd64-linux-gnu"
 		build_target "arm32" "arm-linux-gnu"
 		build_target "ia32" "i686-pc-linux-gnu"
+		build_target "ia64" "ia64-pc-linux-gnu"
 		build_target "ia64" "ia64-pc-linux-gnu"
 		build_target "mips32" "mipsel-linux-gnu"
@@ -405,18 +403,4 @@
 		build_target "sparc64" "sparc64-linux-gnu"
 		;;
-	"parallel")
-		prepare
-		build_target "amd64" "amd64-linux-gnu" &
-		build_target "arm32" "arm-linux-gnu" &
-		build_target "ia32" "i686-pc-linux-gnu" &
-		build_target "ia64" "ia64-pc-linux-gnu" &
-		build_target "mips32" "mipsel-linux-gnu" &
-		build_target "mips32eb" "mips-linux-gnu" &
-		build_target "mips64" "mips64el-linux-gnu" &
-		build_target "ppc32" "ppc-linux-gnu" &
-		build_target "ppc64" "ppc64-linux-gnu" &
-		build_target "sparc64" "sparc64-linux-gnu" &
-		wait
-		;;
 	*)
 		show_usage
Index: uspace/app/bdsh/cmds/modules/cat/cat.c
===================================================================
--- uspace/app/bdsh/cmds/modules/cat/cat.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/app/bdsh/cmds/modules/cat/cat.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -1,4 +1,3 @@
 /* Copyright (c) 2008, Tim Post <tinkertim@gmail.com>
- * Copyright (c) 2011, Martin Sucha
  * All rights reserved.
  *
@@ -36,11 +35,4 @@
 #include <str.h>
 #include <fcntl.h>
-#include <io/console.h>
-#include <io/color.h>
-#include <io/style.h>
-#include <io/keycode.h>
-#include <errno.h>
-#include <vfs/vfs.h>
-#include <assert.h>
 
 #include "config.h"
@@ -56,12 +48,4 @@
 
 static const char *cat_oops = "That option is not yet supported\n";
-static const char *hexchars = "0123456789abcdef";
-
-static bool paging_enabled = false;
-static size_t chars_remaining = 0;
-static size_t lines_remaining = 0;
-static sysarg_t console_cols = 0;
-static sysarg_t console_rows = 0;
-static bool should_quit = false;
 
 static struct option const long_options[] = {
@@ -72,5 +56,4 @@
 	{ "buffer", required_argument, 0, 'b' },
 	{ "more", no_argument, 0, 'm' },
-	{ "hex", no_argument, 0, 'x' },
 	{ 0, 0, 0, 0 }
 };
@@ -92,5 +75,4 @@
 		"  -b, --buffer ##  Set the read buffer size to ##\n"
 		"  -m, --more       Pause after each screen full\n"
-		"  -x, --hex        Print bytes as hex values\n"
 		"Currently, %s is under development, some options don't work.\n",
 		cmdname, cmdname);
@@ -100,71 +82,9 @@
 }
 
-static void waitprompt()
-{
-	console_set_pos(fphone(stdout), 0, console_rows-1);
-	console_set_color(fphone(stdout), COLOR_BLUE, COLOR_WHITE, 0);
-	printf("ENTER/SPACE/PAGE DOWN - next page, "
-	       "ESC/Q - quit, C - continue unpaged");
-	fflush(stdout);
-	console_set_style(fphone(stdout), STYLE_NORMAL);
-}
-
-static void waitkey()
-{
-	console_event_t ev;
-	
-	while (true) {
-		if (!console_get_event(fphone(stdin), &ev)) {
-			return;
-		}
-		if (ev.type == KEY_PRESS) {
-			if (ev.key == KC_ESCAPE || ev.key == KC_Q) {
-				should_quit = true;
-				return;
-			}
-			if (ev.key == KC_C) {
-				paging_enabled = false;
-				return;
-			}
-			if (ev.key == KC_ENTER || ev.key == KC_SPACE ||
-			    ev.key == KC_PAGE_DOWN) {
-				return;
-			}
-		}
-	}
-	assert(false);
-}
-
-static void newpage()
-{
-	console_clear(fphone(stdout));
-	chars_remaining = console_cols;
-	lines_remaining = console_rows-1;
-}
-
-static void paged_char(wchar_t c)
-{
-	putchar(c);
-	if (paging_enabled) {
-		chars_remaining--;
-		if (c == '\n' || chars_remaining == 0) {
-			chars_remaining = console_cols;
-			lines_remaining--;
-		}
-		if (lines_remaining == 0) {
-			fflush(stdout);
-			waitprompt();
-			waitkey();
-			newpage();
-		}
-	}
-}
-
-static unsigned int cat_file(const char *fname, size_t blen, bool hex)
+static unsigned int cat_file(const char *fname, size_t blen)
 {
 	int fd, bytes = 0, count = 0, reads = 0;
+	off64_t total = 0;
 	char *buff = NULL;
-	int i;
-	size_t offset = 0;
 
 	fd = open(fname, O_RDONLY);
@@ -173,4 +93,7 @@
 		return 1;
 	}
+
+	total = lseek(fd, 0, SEEK_END);
+	lseek(fd, 0, SEEK_SET);
 
 	if (NULL == (buff = (char *) malloc(blen + 1))) {
@@ -186,23 +109,8 @@
 			count += bytes;
 			buff[bytes] = '\0';
-			offset = 0;
-			for (i = 0; i < bytes && !should_quit; i++) {
-				if (hex) {
-					paged_char(hexchars[((uint8_t)buff[i])/16]);
-					paged_char(hexchars[((uint8_t)buff[i])%16]);
-				}
-				else {
-					wchar_t c = str_decode(buff, &offset, bytes);
-					if (c == 0) {
-						/* Reached end of string */
-						break;
-					}
-					paged_char(c);
-				}
-				
-			}
+			printf("%s", buff);
 			reads++;
 		}
-	} while (bytes > 0 && !should_quit);
+	} while (bytes > 0);
 
 	close(fd);
@@ -223,24 +131,9 @@
 	unsigned int argc, i, ret = 0, buffer = 0;
 	int c, opt_ind;
-	bool hex = false;
-	bool more = false;
-	sysarg_t rows, cols;
-	int rc;
-	
-	/*
-	 * reset global state
-	 * TODO: move to structure?
-	 */
-	paging_enabled = false;
-	chars_remaining = 0;
-	lines_remaining = 0;
-	console_cols = 0;
-	console_rows = 0;
-	should_quit = false;
 
 	argc = cli_count_args(argv);
 
 	for (c = 0, optind = 0, opt_ind = 0; c != -1;) {
-		c = getopt_long(argc, argv, "xhvmH:t:b:", long_options, &opt_ind);
+		c = getopt_long(argc, argv, "hvmH:t:b:", long_options, &opt_ind);
 		switch (c) {
 		case 'h':
@@ -251,18 +144,15 @@
 			return CMD_SUCCESS;
 		case 'H':
-			printf("%s", cat_oops);
+			printf(cat_oops);
 			return CMD_FAILURE;
 		case 't':
-			printf("%s", cat_oops);
+			printf(cat_oops);
 			return CMD_FAILURE;
 		case 'b':
-			printf("%s", cat_oops);
+			printf(cat_oops);
 			break;
 		case 'm':
-			more = true;
-			break;
-		case 'x':
-			hex = true;
-			break;
+			printf(cat_oops);
+			return CMD_FAILURE;
 		}
 	}
@@ -278,19 +168,7 @@
 	if (buffer <= 0)
 		buffer = CAT_DEFAULT_BUFLEN;
-	
-	if (more) {
-		rc = console_get_size(fphone(stdout), &cols, &rows);
-		if (rc != EOK) {
-			printf("%s - cannot get console size\n", cmdname);
-			return CMD_FAILURE;
-		}
-		console_cols = cols;
-		console_rows = rows;
-		paging_enabled = true;
-		newpage();
-	}
 
-	for (i = optind; argv[i] != NULL && !should_quit; i++)
-		ret += cat_file(argv[i], buffer, hex);
+	for (i = optind; argv[i] != NULL; i++)
+		ret += cat_file(argv[i], buffer);
 
 	if (ret)
Index: uspace/app/bdsh/cmds/modules/cat/cat.h
===================================================================
--- uspace/app/bdsh/cmds/modules/cat/cat.h	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/app/bdsh/cmds/modules/cat/cat.h	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -4,5 +4,5 @@
 /* Prototypes for the cat command, excluding entry points */
 
-static unsigned int cat_file(const char *, size_t, bool);
+static unsigned int cat_file(const char *, size_t);
 
 #endif /* CAT_H */
Index: uspace/app/bdsh/cmds/modules/cp/cp.c
===================================================================
--- uspace/app/bdsh/cmds/modules/cp/cp.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/app/bdsh/cmds/modules/cp/cp.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -108,5 +108,4 @@
 	for (;;) {
 		ssize_t res;
-		size_t written = 0;
 
 		bytes = read(fd1, buff, blen);
@@ -121,8 +120,7 @@
 			 * returned less data than requested.
 			 */
-			bytes = write(fd2, buff + written, res);
+			bytes = write(fd2, buff, res);
 			if (bytes < 0)
 				goto err;
-			written += bytes;
 			res -= bytes;
 		} while (res > 0);
Index: uspace/app/bdsh/cmds/modules/ls/ls.c
===================================================================
--- uspace/app/bdsh/cmds/modules/ls/ls.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/app/bdsh/cmds/modules/ls/ls.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -38,9 +38,7 @@
 #include <dirent.h>
 #include <fcntl.h>
-#include <getopt.h>
 #include <sys/types.h>
 #include <sys/stat.h>
 #include <str.h>
-#include <sort.h>
 
 #include "errors.h"
@@ -48,160 +46,64 @@
 #include "util.h"
 #include "entry.h"
+#include "ls.h"
 #include "cmds.h"
-
-/* Various values that can be returned by ls_scope() */
-#define LS_BOGUS 0
-#define LS_FILE  1
-#define LS_DIR   2
-
-/** Structure to represent a directory entry.
- *
- * Useful to keep together important information
- * for sorting directory entries.
- */
-struct dir_elem_t {
-	char *name;
-	struct stat s;
-};
 
 static const char *cmdname = "ls";
 
-static struct option const long_options[] = {
-	{ "help", no_argument, 0, 'h' },
-	{ "unsort", no_argument, 0, 'u' },
-	{ 0, 0, 0, 0 }
-};
+static void ls_scan_dir(const char *d, DIR *dirp)
+{
+	struct dirent *dp;
+	char *buff;
 
-/** Print an entry.
- *
- * ls_print currently does nothing more than print the entry.
- * In the future, we will likely pass the absolute path, and
+	if (! dirp)
+		return;
+
+	buff = (char *)malloc(PATH_MAX);
+	if (NULL == buff) {
+		cli_error(CL_ENOMEM, "ls: failed to scan %s", d);
+		return;
+	}
+
+	while ((dp = readdir(dirp))) {
+		memset(buff, 0, sizeof(buff));
+		/* Don't worry if inserting a double slash, this will be fixed by
+		 * absolutize() later with subsequent calls to open() or readdir() */
+		snprintf(buff, PATH_MAX - 1, "%s/%s", d, dp->d_name);
+		ls_print(dp->d_name, buff);
+	}
+
+	free(buff);
+
+	return;
+}
+
+/* ls_print currently does nothing more than print the entry.
+ * in the future, we will likely pass the absolute path, and
  * some sort of ls_options structure that controls how each
  * entry is printed and what is printed about it.
  *
- * Now we just print basic DOS style lists.
- *
- * @param de		Directory element.
- */
-static void ls_print(struct dir_elem_t *de)
+ * Now we just print basic DOS style lists */
+
+static void ls_print(const char *name, const char *pathname)
 {
-	if (de->s.is_file)
-		printf("%-40s\t%llu\n", de->name, (long long) de->s.size);
-	else if (de->s.is_directory)
-		printf("%-40s\t<dir>\n", de->name);
-	else
-		printf("%-40s\n", de->name);
-}
+	struct stat s;
+	int rc;
 
-
-/** Compare 2 directory elements.
- *
- * It compares 2 elements of a directory : a file is considered
- * as bigger than a directory, and if they have the same type,
- * they are compared alphabetically.
- *
- * @param a		Pointer to the structure of the first element.
- * @param b		Pointer to the structure of the second element.
- * @param arg		Pointer for an other and optionnal argument.
- *
- * @return		-1 if a < b, 1 otherwise.
- */
-static int ls_cmp(void *a, void *b, void *arg)
-{
-	struct dir_elem_t *da = a;
-	struct dir_elem_t *db = b;
-	
-	if ((da->s.is_directory && db->s.is_file) ||
-	    ((da->s.is_directory == db->s.is_directory) &&
-	    str_cmp(da->name, db->name) < 0))
-		return -1;
-	else
-		return 1;
-}
-
-/** Scan a directory.
- *
- * Scan the content of a directory and print it.
- *
- * @param d		Name of the directory.
- * @param dirp	Directory stream.
- * @param sort	1 if the output must be sorted,
- *				0 otherwise.
- */
-static void ls_scan_dir(const char *d, DIR *dirp, int sort)
-{
-	int alloc_blocks = 20;
-	int i;
-	int nbdirs = 0;
-	int rc;
-	int len;
-	char *buff;
-	struct dir_elem_t *tmp;
-	struct dir_elem_t *tosort;
-	struct dirent *dp;
-	
-	if (!dirp)
-		return;
-
-	buff = (char *) malloc(PATH_MAX);
-	if (!buff) {
-		cli_error(CL_ENOMEM, "ls: failed to scan %s", d);
+	rc = stat(pathname, &s);
+	if (rc != 0) {
+		/* Odd chance it was deleted from the time readdir() found it */
+		printf("ls: skipping bogus node %s\n", pathname);
+		printf("rc=%d\n", rc);
 		return;
 	}
 	
-	tosort = (struct dir_elem_t *) malloc(alloc_blocks * sizeof(*tosort));
-	if (!tosort) {
-		cli_error(CL_ENOMEM, "ls: failed to scan %s", d);
-		free(buff);
-		return;
-	}
-	
-	while ((dp = readdir(dirp))) {
-		if (nbdirs + 1 > alloc_blocks) {
-			alloc_blocks += alloc_blocks;
-			
-			tmp = (struct dir_elem_t *) realloc(tosort,
-			    alloc_blocks * sizeof(struct dir_elem_t));
-			if (!tmp) {
-				cli_error(CL_ENOMEM, "ls: failed to scan %s", d);
-				goto out;
-			}
-			tosort = tmp;
-		}
-		
-		/* fill the name field */
-		tosort[nbdirs].name = (char *) malloc(str_length(dp->d_name) + 1);
-		if (!tosort[nbdirs].name) {
-			cli_error(CL_ENOMEM, "ls: failed to scan %s", d);
-			goto out;
-		}
-		
-		str_cpy(tosort[nbdirs].name, str_length(dp->d_name) + 1, dp->d_name);
-		len = snprintf(buff, PATH_MAX - 1, "%s/%s", d, tosort[nbdirs].name);
-		buff[len] = '\0';
+	if (s.is_file)
+		printf("%-40s\t%llu\n", name, (long long) s.size);
+	else if (s.is_directory)
+		printf("%-40s\t<dir>\n", name);
+	else
+		printf("%-40s\n", name);
 
-		rc = stat(buff, &tosort[nbdirs++].s);
-		if (rc != 0) {
-			printf("ls: skipping bogus node %s\n", buff);
-			printf("rc=%d\n", rc);
-			goto out;
-		}
-	}
-	
-	if (sort) {
-		if (!qsort(&tosort[0], nbdirs, sizeof(struct dir_elem_t),
-		    ls_cmp, NULL)) {
-			printf("Sorting error.\n");
-		}
-	}
-	
-	for (i = 0; i < nbdirs; i++)
-		ls_print(&tosort[i]);
-	
-out:
-	for(i = 0; i < nbdirs; i++)
-		free(tosort[i].name);
-	free(tosort);
-	free(buff);
+	return;
 }
 
@@ -212,11 +114,6 @@
 	} else {
 		help_cmd_ls(HELP_SHORT);
-		printf(
-		"Usage:  %s [options] [path]\n"
-		"If not path is given, the current working directory is used.\n"
-		"Options:\n"
-		"  -h, --help       A short option summary\n"
-		"  -u, --unsort     Do not sort directory entries\n",
-		cmdname);
+		printf("  `%s' [path], if no path is given the current "
+				"working directory is used.\n", cmdname);
 	}
 
@@ -227,58 +124,43 @@
 {
 	unsigned int argc;
-	struct dir_elem_t de;
+	struct stat s;
+	char *buff;
 	DIR *dirp;
-	int c, opt_ind;
-	int sort = 1;
 
 	argc = cli_count_args(argv);
-	
-	for (c = 0, optind = 0, opt_ind = 0; c != -1;) {
-		c = getopt_long(argc, argv, "hu", long_options, &opt_ind);
-		switch (c) {
-		case 'h':
-			help_cmd_ls(HELP_LONG);
-			return CMD_SUCCESS;
-		case 'u':
-			sort = 0;
-			break;
-		}
-	}
-	
-	argc -= optind;
-	
-	de.name = (char *) malloc(PATH_MAX);
-	if (!de.name) {
+
+	buff = (char *) malloc(PATH_MAX);
+	if (NULL == buff) {
 		cli_error(CL_ENOMEM, "%s: ", cmdname);
 		return CMD_FAILURE;
 	}
-	memset(de.name, 0, sizeof(PATH_MAX));
-	
-	if (argc == 0)
-		getcwd(de.name, PATH_MAX);
+	memset(buff, 0, sizeof(buff));
+
+	if (argc == 1)
+		getcwd(buff, PATH_MAX);
 	else
-		str_cpy(de.name, PATH_MAX, argv[optind]);
-	
-	if (stat(de.name, &de.s)) {
-		cli_error(CL_ENOENT, de.name);
-		free(de.name);
+		str_cpy(buff, PATH_MAX, argv[1]);
+
+	if (stat(buff, &s)) {
+		cli_error(CL_ENOENT, buff);
+		free(buff);
 		return CMD_FAILURE;
 	}
 
-	if (de.s.is_file) {
-		ls_print(&de);
+	if (s.is_file) {
+		ls_print(buff, buff);
 	} else {
-		dirp = opendir(de.name);
+		dirp = opendir(buff);
 		if (!dirp) {
 			/* May have been deleted between scoping it and opening it */
-			cli_error(CL_EFAIL, "Could not stat %s", de.name);
-			free(de.name);
+			cli_error(CL_EFAIL, "Could not stat %s", buff);
+			free(buff);
 			return CMD_FAILURE;
 		}
-		ls_scan_dir(de.name, dirp, sort);
+		ls_scan_dir(buff, dirp);
 		closedir(dirp);
 	}
 
-	free(de.name);
+	free(buff);
 
 	return CMD_SUCCESS;
Index: uspace/app/bdsh/cmds/modules/ls/ls.h
===================================================================
--- uspace/app/bdsh/cmds/modules/ls/ls.h	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
+++ uspace/app/bdsh/cmds/modules/ls/ls.h	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -0,0 +1,13 @@
+#ifndef LS_H
+#define LS_H
+
+/* Various values that can be returned by ls_scope() */
+#define LS_BOGUS 0
+#define LS_FILE  1
+#define LS_DIR   2
+
+static void ls_scan_dir(const char *, DIR *);
+static void ls_print(const char *, const char *);
+
+#endif /* LS_H */
+
Index: uspace/app/bdsh/cmds/modules/rm/rm.c
===================================================================
--- uspace/app/bdsh/cmds/modules/rm/rm.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/app/bdsh/cmds/modules/rm/rm.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -101,42 +101,7 @@
 }
 
-static unsigned int rm_recursive_not_empty_dirs(const char *path)
-{
-	DIR *dirp;
-	struct dirent *dp;
-	char buff[PATH_MAX];
-	unsigned int scope;
-	unsigned int ret = 0;
-
-	dirp = opendir(path);
-	if (!dirp) {
-		/* May have been deleted between scoping it and opening it */
-		cli_error(CL_EFAIL, "Could not open %s", path);
-		return ret;
-	}
-
-	memset(buff, 0, sizeof(buff));
-	while ((dp = readdir(dirp))) {
-		snprintf(buff, PATH_MAX - 1, "%s/%s", path, dp->d_name);
-		scope = rm_scope(buff);
-		switch (scope) {
-		case RM_BOGUS:
-			break;
-		case RM_FILE:
-			ret += rm_single(buff);
-			break;
-		case RM_DIR:
-			ret += rm_recursive(buff);
-			break;
-		}
-	}
-	
-	return ret;
-}
-
 static unsigned int rm_recursive(const char *path)
 {
 	int rc;
-	unsigned int ret = 0;
 
 	/* First see if it will just go away */
@@ -146,14 +111,7 @@
 
 	/* Its not empty, recursively scan it */
-	ret = rm_recursive_not_empty_dirs(path);
-
-	/* Delete directory */
-	rc = rmdir(path);
-	if (rc == 0)
-		return ret;
-
-	cli_error(CL_ENOTSUP, "Can not remove %s", path);
-
-	return ret + 1;
+	cli_error(CL_ENOTSUP,
+		"Can not remove %s, directory not empty", path);
+	return 1;
 }
 
@@ -269,5 +227,5 @@
 		}
 		memset(buff, 0, sizeof(buff));
-		snprintf(buff, len, "%s", argv[i]);
+		snprintf(buff, len, argv[i]);
 
 		scope = rm_scope(buff);
Index: uspace/app/init/init.c
===================================================================
--- uspace/app/init/init.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/app/init/init.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -272,7 +272,4 @@
 	mount_tmpfs();
 	
-#ifdef CONFIG_START_DEVMAN
-	spawn("/srv/devman");
-#endif
 	spawn("/srv/apic");
 	spawn("/srv/i8259");
Index: uspace/app/sbi/src/run_expr.c
===================================================================
--- uspace/app/sbi/src/run_expr.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/app/sbi/src/run_expr.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -2529,6 +2529,4 @@
 	if (rc1 == EOK)
 		rc2 = os_str_get_char(string->value, elem_index, &cval);
-	else
-		rc2 = EOK;
 
 	if (rc1 != EOK || rc2 != EOK) {
Index: uspace/app/stats/stats.c
===================================================================
--- uspace/app/stats/stats.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/app/stats/stats.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -265,5 +265,5 @@
 		/* Threads */
 		if ((off = arg_parse_short_long(argv[i], "-t", "--task=")) != -1) {
-			/* TODO: Support for 64b range */
+			// TODO: Support for 64b range
 			int tmp;
 			int ret = arg_parse_int(argc, argv, &i, &tmp, off);
Index: uspace/app/tester/Makefile
===================================================================
--- uspace/app/tester/Makefile	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/app/tester/Makefile	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -49,5 +49,4 @@
 	loop/loop1.c \
 	mm/malloc1.c \
-	devs/devman1.c \
 	hw/misc/virtchar1.c \
 	hw/serial/serial1.c
Index: uspace/app/tester/fault/fault2.c
===================================================================
--- uspace/app/tester/fault/fault2.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/app/tester/fault/fault2.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -29,5 +29,4 @@
 
 #include "../tester.h"
-#include <stdio.h>
 
 typedef int __attribute__((may_alias)) aliasing_int;
@@ -39,5 +38,4 @@
 	
 	var1 = *((aliasing_int *) (((char *) (&var)) + 1));
-	printf("Read %d\n", var1);
 	
 	return "Survived unaligned read";
Index: uspace/app/tester/tester.c
===================================================================
--- uspace/app/tester/tester.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/app/tester/tester.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -64,5 +64,4 @@
 #include "hw/serial/serial1.def"
 #include "hw/misc/virtchar1.def"
-#include "devs/devman1.def"
 	{NULL, NULL, NULL, false}
 };
Index: uspace/app/tester/tester.h
===================================================================
--- uspace/app/tester/tester.h	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/app/tester/tester.h	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -80,5 +80,4 @@
 extern const char *test_serial1(void);
 extern const char *test_virtchar1(void);
-extern const char *test_devman1(void);
 
 extern test_t tests[];
Index: uspace/app/trace/trace.c
===================================================================
--- uspace/app/trace/trace.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/app/trace/trace.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -53,5 +53,5 @@
 #include <libc.h>
 
-/* Temporary: service and method names */
+// Temporary: service and method names
 #include "proto.h"
 #include <ipc/services.h>
@@ -872,5 +872,5 @@
 static display_mask_t parse_display_mask(const char *text)
 {
-	display_mask_t dm = 0;
+	display_mask_t dm;
 	const char *c = text;
 	
Index: uspace/drv/isa/isa.c
===================================================================
--- uspace/drv/isa/isa.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/drv/isa/isa.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -53,5 +53,4 @@
 
 #include <ddf/driver.h>
-#include <ddf/log.h>
 #include <ops/hw_res.h>
 
@@ -83,5 +82,5 @@
 static bool isa_enable_fun_interrupt(ddf_fun_t *fnode)
 {
-	/* TODO */
+	// TODO
 
 	return false;
@@ -135,5 +134,5 @@
 	fd = open(conf_path, O_RDONLY);
 	if (fd < 0) {
-		ddf_msg(LVL_ERROR, "Unable to open %s", conf_path);
+		printf(NAME ": unable to open %s\n", conf_path);
 		goto cleanup;
 	}
@@ -142,8 +141,8 @@
 
 	len = lseek(fd, 0, SEEK_END);
-	lseek(fd, 0, SEEK_SET);
+	lseek(fd, 0, SEEK_SET);	
 	if (len == 0) {
-		ddf_msg(LVL_ERROR, "Configuration file '%s' is empty.",
-		    conf_path);
+		printf(NAME ": fun_conf_read error: configuration file '%s' "
+		    "is empty.\n", conf_path);
 		goto cleanup;
 	}
@@ -151,10 +150,11 @@
 	buf = malloc(len + 1);
 	if (buf == NULL) {
-		ddf_msg(LVL_ERROR, "Memory allocation failed.");
+		printf(NAME ": fun_conf_read error: memory allocation failed.\n");
 		goto cleanup;
 	}
 
 	if (0 >= read(fd, buf, len)) {
-		ddf_msg(LVL_ERROR, "Unable to read file '%s'.", conf_path);
+		printf(NAME ": fun_conf_read error: unable to read file '%s'.\n",
+		    conf_path);
 		goto cleanup;
 	}
@@ -252,5 +252,5 @@
 		fun->hw_resources.count++;
 
-		ddf_msg(LVL_NOTE, "Added irq 0x%x to function %s", irq,
+		printf(NAME ": added irq 0x%x to function %s\n", irq,
 		    fun->fnode->name);
 	}
@@ -270,6 +270,6 @@
 		fun->hw_resources.count++;
 
-		ddf_msg(LVL_NOTE, "Added io range (addr=0x%x, size=0x%x) to "
-		    "function %s", (unsigned int) addr, (unsigned int) len,
+		printf(NAME ": added io range (addr=0x%x, size=0x%x) to "
+		    "function %s\n", (unsigned int) addr, (unsigned int) len,
 		    fun->fnode->name);
 	}
@@ -331,6 +331,6 @@
 	score = (int)strtol(val, &end, 10);
 	if (val == end) {
-		ddf_msg(LVL_ERROR, "Cannot read match score for function "
-		    "%s.", fun->fnode->name);
+		printf(NAME " : error - could not read match score for "
+		    "function %s.\n", fun->fnode->name);
 		return;
 	}
@@ -339,17 +339,15 @@
 	get_match_id(&id, val);
 	if (id == NULL) {
-		ddf_msg(LVL_ERROR, "Cannot read match ID for function %s.",
-		    fun->fnode->name);
+		printf(NAME " : error - could not read match id for "
+		    "function %s.\n", fun->fnode->name);
 		return;
 	}
 
-	ddf_msg(LVL_DEBUG, "Adding match id '%s' with score %d to "
-	    "function %s", id, score, fun->fnode->name);
+	printf(NAME ": adding match id '%s' with score %d to function %s\n", id,
+	    score, fun->fnode->name);
 
 	rc = ddf_fun_add_match_id(fun->fnode, id, score);
-	if (rc != EOK) {
-		ddf_msg(LVL_ERROR, "Failed adding match ID: %s",
-		    str_error(rc));
-	}
+	if (rc != EOK)
+		printf(NAME ": error adding match ID: %s\n", str_error(rc));
 }
 
@@ -377,8 +375,8 @@
 	if (!prop_parse(fun, line, "io_range", &fun_parse_io_range) &&
 	    !prop_parse(fun, line, "irq", &fun_parse_irq) &&
-	    !prop_parse(fun, line, "match", &fun_parse_match_id)) {
-
-		ddf_msg(LVL_ERROR, "Undefined device property at line '%s'",
-		    line);
+	    !prop_parse(fun, line, "match", &fun_parse_match_id))
+	{
+	    printf(NAME " error undefined device property at line '%s'\n",
+		line);
 	}
 }
@@ -441,5 +439,5 @@
 	fun->fnode->ops = &isa_fun_ops;
 
-	ddf_msg(LVL_DEBUG, "Binding function %s.", fun->fnode->name);
+	printf(NAME ": Binding function %s.\n", fun->fnode->name);
 
 	/* XXX Handle error */
@@ -469,18 +467,18 @@
 static int isa_add_device(ddf_dev_t *dev)
 {
-	ddf_msg(LVL_DEBUG, "isa_add_device, device handle = %d",
+	printf(NAME ": isa_add_device, device handle = %d\n",
 	    (int) dev->handle);
 
 	/* Make the bus device more visible. Does not do anything. */
-	ddf_msg(LVL_DEBUG, "Adding a 'ctl' function");
+	printf(NAME ": adding a 'ctl' function\n");
 
 	ddf_fun_t *ctl = ddf_fun_create(dev, fun_exposed, "ctl");
 	if (ctl == NULL) {
-		ddf_msg(LVL_ERROR, "Failed creating control function.");
+		printf(NAME ": Error creating control function.\n");
 		return EXDEV;
 	}
 
 	if (ddf_fun_bind(ctl) != EOK) {
-		ddf_msg(LVL_ERROR, "Failed binding control function.");
+		printf(NAME ": Error binding control function.\n");
 		return EXDEV;
 	}
@@ -488,5 +486,5 @@
 	/* Add functions as specified in the configuration file. */
 	isa_functions_add(dev);
-	ddf_msg(LVL_NOTE, "Finished enumerating legacy functions");
+	printf(NAME ": finished the enumeration of legacy functions\n");
 
 	return EOK;
@@ -495,5 +493,4 @@
 static void isa_init() 
 {
-	ddf_log_init(NAME, LVL_ERROR);
 	isa_fun_ops.interfaces[HW_RES_DEV_IFACE] = &isa_fun_hw_res_ops;
 }
